package Server_Client.NetWorkGame;

import UI.GameState.BulletState;
import UI.GameState.EnemyTank;
import UI.GameState.TankState;
import UI.GameState.WallState;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.net.Socket;
import java.util.ArrayList;
import java.util.Scanner;

public class Client1 {
    private Socket socket = null;
    private String host;
    private int port;
    private int enemyX;
    private int enemyY;
    private int enemyRotate;
    private int enemyBulletX;
    private int enemyBulletY;
    private boolean enemyHasLaser;
    private boolean enemyHasShield;
    private boolean enemyHasMoreLife;
    private WallState wallState;
    private ArrayList<EnemyTank> enemyTanks;
    private ArrayList<BulletState> eachTankBullets;
    private String serverAns;

    public Client1(String address , int port) {
        this.host = address;
        this.port = port;
    }

    private String tankStateToString (TankState tank) throws IOException {
        String tankComponent , bulletComponent = "";
        tankComponent = tank.locX +" "+ tank.locY+" " +tank.rotate +" "+tank.hasShield() +" "+tank.hasLaser() +" "+tank.isHasMoreLife();
        for (BulletState bullet : tank.getBullets()){
            bulletComponent +=" " + bullet.locX + " " + bullet.locY + " " ; 
        }
        return tankComponent + bulletComponent;
    }

    public void run(TankState tankState) {
        try{
            socket = new Socket(host,port);
            OutputStream out = socket.getOutputStream();
            InputStream in = socket.getInputStream();

            out.write("Client1".getBytes());
            String text = "";

            boolean running = true;
            do {
                //ToDo update the tank and enemy tank x , y , ...
                text = tankStateToString(tankState);
                running = !text.equalsIgnoreCase("over");

                out.write(text.getBytes());

                byte[] buffer = new byte[2048];
                int read = in.read(buffer);
                serverAns  = new String(buffer,0,read);
                System.out.println("- From Server : "+serverAns);
            }while(running);

            System.out.println("Client disconnected.");
            socket.close();
        }catch (IOException e){
            System.out.println("Error : "+e.getMessage());
            e.printStackTrace();
        }
    }

    private ArrayList<EnemyTank> createEnemyTanks(String s){
        ArrayList<EnemyTank> enemyTanks = new ArrayList<>();
        int numOfEnemies = findNumOfEnemies(s);
        for (int i = 0 ; i < numOfEnemies ; i ++){
            EnemyTank enemyTank = new EnemyTank(wallState);
            enemyTanks.add(enemyTank);
        }
        return enemyTanks;
    }
    //ToDo
    private int findNumOfEnemies(String s){

    }

    private void parser(){//ToDO separate tanks and each tank bullets

    }

    public void updateEnemyComponents(){
        for (EnemyTank enemyTank : enemyTanks){
            enemyTank.locX = enemyX;
            enemyTank.locY = enemyY;
            enemyTank.rotate =enemyRotate;
            enemyTank.setHasShield(enemyHasShield);
            enemyTank.setHasLaser(enemyHasLaser);
            enemyTank.setHasMoreLife(enemyHasMoreLife);
            for (BulletState bullet : enemyTank.getBullets()){
                bullet.locX = enemyBulletX;
                bullet.locY = enemyBulletY;
            }
        }
    }

    public ArrayList<EnemyTank> getEnemyTanks() {
        return enemyTanks = createEnemyTanks(serverAns);
    }

    public WallState getWallState() {
        return wallState;
    }
}
